
import internal.object;
import std.c.stdio;

class ArrayBoundsError : Object
{
    uint linnum;
    char[] filename;
    int index;
    int length;

    this(int index, int length, char[] filename, uint linnum)
    {
        this.index = index;
        this.length = length;
        this.linnum = linnum;
        this.filename = filename;
    }

  public:

    /***************************************
     * If nobody catches the ArrayBoundsError, this winds up
     * getting called by the startup code.
     */

    char [] toString ()
    {
        return fmt ("ArrayBoundsError %s(%u), out of range (0 <= %d < %d)", (char *) filename, linnum, index, length);
    }
}


/********************************************
 * Called by the compiler generated module assert function.
 * Builds an ArrayBoundsError exception and throws it.
 */

extern (C) void _d_array_bounds (int index, int length, char[] filename, uint line)
{
    //printf("_d_assert(%s, %d)\n", (char *)filename, line);
    ArrayBoundsError a = new ArrayBoundsError(index, length, filename, line);
    //printf("assertion %p created\n", a);
    throw a;
}
