
import internal.object;
import std.c.stdio;

class Assert : Object
{
  private:

    uint linnum;
    char [] filename;
    char [] test;

    this(char[] filename, uint linnum, char [] test)
    {
    this.linnum = linnum;
    this.filename = filename;
        this.test = test;
    }

  public:

    /***************************************
     * If nobody catches the Assert, this winds up
     * getting called by the startup code.
     */

    char [] toString ()
    {
        return fmt ("Assertion Failure %s(%u): %s", filename, linnum, test);
//    printf("Assertion Failure %s(%u): %.*s\n", (char *)filename, linnum, test);
    }
}


/********************************************
 * Called by the compiler generated module assert function.
 * Builds an Assert exception and throws it.
 */

extern (C)
void _d_assert(char[] filename, uint line, char [] test)
{
    //printf("_d_assert(%s, %d)\n", (char *)filename, line);
    Assert a = new Assert(filename, line, test);
    //printf("assertion %p created\n", a);
    throw a;
}

